Stylistic changes to geo (#100)

This commit is contained in:
Reto Kromer 2017-07-27 14:21:51 +02:00 committed by Alex Epstein
parent 6ccaa83576
commit fc85d432bd
1 changed files with 62 additions and 74 deletions

136
geo/geo
View File

@ -1,75 +1,72 @@
#!/usr/bin/env bash #!/usr/bin/env bash
#
# Bash utility for getting specific network info # Bash utility for getting specific network info
# Author: Jake Meyer # Author: Jake Meyer
# Github: https://github.com/jakewmeyer # Github: https://github.com/jakewmeyer
#
currentVersion="1.15.2" currentVersion="1.15.2"
configuredClient="" configuredClient=""
## This function determines which http get tool the system has installed and returns an error if there isnt one ## This function determines which http get tool the system has installed and returns an error if there isnt one
getConfiguredClient() getConfiguredClient() {
{ if command -v curl &>/dev/null; then
if command -v curl &>/dev/null ; then
configuredClient="curl" configuredClient="curl"
elif command -v wget &>/dev/null ; then elif command -v wget &>/dev/null; then
configuredClient="wget" configuredClient="wget"
elif command -v fetch &>/dev/null ; then elif command -v fetch &>/dev/null; then
configuredClient="fetch" configuredClient="fetch"
else else
echo "Error: This tool reqires either curl, wget, or fetch to be installed." echo "Error: This tool reqires either curl, wget, or fetch to be installed."
return 1 return 1
fi fi
} }
## Allows to call the users configured client without if statements everywhere ## Allows to call the users configured client without if statements everywhere
httpGet() httpGet() {
{
case "$configuredClient" in case "$configuredClient" in
curl) curl -A curl -s "$@";; curl) curl -A curl -s "$@" ;;
wget) wget -qO- "$@";; wget) wget -qO- "$@" ;;
fetch) fetch -o "...";; fetch) fetch -o "..." ;;
esac esac
} }
# Parse arguments passed + help formatting # Parse arguments passed + help formatting
usage() { usage() {
echo "Geo" cat <<EOF
echo "Description: Provides quick access for wan, lan, router, dns, mac, and ip geolocation data" Geo
echo "Usage: geo [flag]" Description: Provides quick access for wan, lan, router, dns, mac, and ip geolocation data
echo " -w Returns WAN IP" Usage: geo [flag]
echo " -l Returns LAN IP(s)" -w Returns WAN IP
echo " -r Returns Router IP" -l Returns LAN IP(s)
echo " -d Returns DNS Nameserver" -r Returns Router IP
echo " -m Returns MAC address for interface. Ex. eth0" -d Returns DNS Nameserver
echo " -g Returns Current IP Geodata" -m Returns MAC address for interface. Ex. eth0
echo "Examples:" -g Returns Current IP Geodata
echo " geo -g" Examples:
echo " geo -wlrdgm eth0" geo -g
echo "Custom Geo Output =>" geo -wlrdgm eth0
echo "[all] [query] [city] [region] [country] [zip] [isp]" Custom Geo Output => [all] [query] [city] [region] [country] [zip] [isp]
echo "Example: geo -a 8.8.8.8 -o city,zip,isp" Example: geo -a 8.8.8.8 -o city,zip,isp
echo " -o [options] Returns Specific Geodata" -o [options] Returns Specific Geodata
echo " -a [address] For specific ip in -s" -a [address] For specific IP in -s
echo " -v Returns Version" -v Returns Version
echo " -h Returns Help Screen" -h Returns Help Screen
echo " -u Updates Bash-Snippets" -u Updates Bash-Snippets
EOF
exit exit
} }
# Displays version number # Displays version number
version() { version() {
echo "Version $currentVersion"; echo "Version $currentVersion"
} }
# Fetches WAN ip address # Fetches WAN IP address
wan_search() { wan_search() {
httpGet https://api.ipify.org?format=json | grep -Eo "[0-9.]*" httpGet https://api.ipify.org?format=json | grep -Eo "[0-9.]*"
} }
# Fetches current LAN ip address # Fetches current LAN IP address
lan_search() { lan_search() {
if [ "$(uname)" = "Darwin" ]; then if [ "$(uname)" = "Darwin" ]; then
ifconfig | grep -Eo 'inet (addr:)?([0-9]*\.){3}[0-9]*' | grep -Eo '([0-9]*\.){3}[0-9]*' | grep -v '127.0.0.1' ifconfig | grep -Eo 'inet (addr:)?([0-9]*\.){3}[0-9]*' | grep -Eo '([0-9]*\.){3}[0-9]*' | grep -v '127.0.0.1'
@ -131,9 +128,7 @@ specific_geo() {
fi fi
} }
update() {
update()
{
# Author: Alexander Epstein https://github.com/alexanderepstein # Author: Alexander Epstein https://github.com/alexanderepstein
# Update utility version 1.2.0 # Update utility version 1.2.0
# To test the tool enter in the defualt values that are in the examples for each variable # To test the tool enter in the defualt values that are in the examples for each variable
@ -142,10 +137,10 @@ update()
nameOfInstallFile="install.sh" # change this if the installer file has a different name be sure to include file extension if there is one nameOfInstallFile="install.sh" # change this if the installer file has a different name be sure to include file extension if there is one
latestVersion=$(httpGet https://api.github.com/repos/$githubUserName/$repositoryName/tags | grep -Eo '"name":.*?[^\\]",'| head -1 | grep -Eo "[0-9.]+" ) #always grabs the tag without the v option latestVersion=$(httpGet https://api.github.com/repos/$githubUserName/$repositoryName/tags | grep -Eo '"name":.*?[^\\]",'| head -1 | grep -Eo "[0-9.]+" ) #always grabs the tag without the v option
if [[ $currentVersion == "" || $repositoryName == "" || $githubUserName == "" || $nameOfInstallFile == "" ]];then if [[ $currentVersion == "" || $repositoryName == "" || $githubUserName == "" || $nameOfInstallFile == "" ]]; then
echo "Error: update utility has not been configured correctly." >&2 echo "Error: update utility has not been configured correctly." >&2
exit 1 exit 1
elif [[ $latestVersion == "" ]];then elif [[ $latestVersion == "" ]]; then
echo "Error: no active internet connection" >&2 echo "Error: no active internet connection" >&2
exit 1 exit 1
else else
@ -153,16 +148,16 @@ update()
echo "Version $latestVersion available" echo "Version $latestVersion available"
echo -n "Do you wish to update $repositoryName [Y/n]: " echo -n "Do you wish to update $repositoryName [Y/n]: "
read -r answer read -r answer
if [[ "$answer" == "Y" || "$answer" == "y" ]] ;then if [[ "$answer" == [Yy] ]] ;then
cd ~ || { echo 'Update Failed' ; exit 1 ; } cd ~ || { echo 'Update Failed'; exit 1; }
if [[ -d ~/$repositoryName ]]; then rm -r -f $repositoryName || { echo "Permissions Error: try running the update as sudo"; exit 1; } ; fi if [[ -d ~/$repositoryName ]]; then rm -r -f $repositoryName || { echo "Permissions Error: try running the update as sudo"; exit 1; } ; fi
git clone "https://github.com/$githubUserName/$repositoryName" || { echo "Couldn't download latest version" ; exit 1; } git clone "https://github.com/$githubUserName/$repositoryName" || { echo "Couldn't download latest version" ; exit 1; }
cd $repositoryName || { echo 'Update Failed' ; exit 1 ;} cd $repositoryName || { echo 'Update Failed' ; exit 1 ;}
git checkout "v$latestVersion" 2> /dev/null || git checkout "$latestVersion" 2> /dev/null || echo "Couldn't git checkout to stable release, updating to latest commit." git checkout "v$latestVersion" 2> /dev/null || git checkout "$latestVersion" 2> /dev/null || echo "Couldn't git checkout to stable release, updating to latest commit."
chmod a+x install.sh #this might be necessary in your case but wasnt in mine. chmod a+x install.sh #this might be necessary in your case but wasnt in mine.
./$nameOfInstallFile "update" || exit 1 ./$nameOfInstallFile "update" || exit 1
cd .. cd ..
rm -r -f $repositoryName || { echo "Permissions Error: update succesfull but cannot delete temp files located at ~/$repositoryName delete this directory with sudo"; exit 1; } rm -r -f $repositoryName || { echo "Permissions Error: update succesfull but cannot delete temp files located at ~/$repositoryName delete this directory with sudo"; exit 1; }
else else
exit 1 exit 1
fi fi
@ -170,45 +165,38 @@ update()
echo "$repositoryName is already the latest version" echo "$repositoryName is already the latest version"
fi fi
fi fi
} }
checkInternet() {
checkInternet()
{
httpGet google.com > /dev/null 2>&1 || { echo "Error: no active internet connection" >&2; return 1; } # query google with a get request httpGet google.com > /dev/null 2>&1 || { echo "Error: no active internet connection" >&2; return 1; } # query google with a get request
} }
# Option parsing "controller" # Option parsing "controller"
optspec="uwlrdm:go:a:vh*:" optspec="uwlrdm:go:a:vh*:"
while getopts "$optspec" optchar while getopts "$optspec" optchar; do
do case "${optchar}" in
case "${optchar}" in w) getConfiguredClient && checkInternet && wan_search || exit 1 ;;
w) getConfiguredClient && checkInternet && wan_search || exit 1;; l) lan_search ;;
l) lan_search ;; r) router_search ;;
r) router_search ;; d) dns_search ;;
d) dns_search ;; m) MAC=$OPTARG mac_search ;;
m) MAC=$OPTARG mac_search;; g) getConfiguredClient && checkInternet && geodata_search || exit 1 ;;
g) getConfiguredClient && checkInternet && geodata_search || exit 1 ;; a) ADDRESS=$OPTARG ;;
a) ADDRESS=$OPTARG ;; o) getConfiguredClient && checkInternet && OPTIONS=$OPTARG specific_geo || exit 1 ;;
o) getConfiguredClient && checkInternet && OPTIONS=$OPTARG specific_geo || exit 1 ;; v) version ;;
v) version ;; h) usage ;;
h) usage ;; u) getConfiguredClient && checkInternet && update || exit 1 ;;
u) getConfiguredClient && checkInternet && update || exit 1 ;; *) usage ;;
*) usage ;; esac
esac
done done
# Makes geo command default to help screen for usability # Makes geo command default to help screen for usability
if [ $# -eq 0 ]; if [ $# -eq 0 ]; then
then usage
usage exit 0
exit 0 elif [[ $1 == "update" ]]; then
elif [[ $1 == "update" ]];then
getConfiguredClient && checkInternet && update || exit 1 getConfiguredClient && checkInternet && update || exit 1
elif [[ $1 == "help" ]];then elif [[ $1 == "help" ]]; then
usage usage
exit 0 exit 0
fi fi